## dde-grand-search 5.2.3

=== CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 显示编译过程
set(CMAKE_VERBOSE_MAKEFILE ON)

# 设置工程名字
project(dde-grand-search)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_DEBUG")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need")

#安全加固
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -z now")
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -z relro")
endif()

configure_file(${CMAKE_SOURCE_DIR}/src/environments.h.in ${CMAKE_SOURCE_DIR}/src/environments.h @ONLY)

include_directories(${CMAKE_SOURCE_DIR}/src)

# 平台库目录
set(LIB_PLATFORM_DIR "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}")

#全局文件
FILE(GLOB GLOBAL_SRC "./src/global/*.h" "./src/global/*.cpp" "./src/global/accessibility/*.h")

# 国际化
if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")

    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

# 定义前端可执行程序名称
set(SEARCH_BIN_NAME dde-grand-search)

# 定义前端应用库目录
set(SEARCH_LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${SEARCH_BIN_NAME}")

# 定义前端插件目录
set(SEARCH_PLUGIN_BASE_DIR "${SEARCH_LIB_BASE_DIR}/plugins")

# 定义前端预览插件目录
set(PLUGIN_PREVIEW_DIR "${SEARCH_PLUGIN_BASE_DIR}/preview")
add_definitions(-DPLUGIN_PREVIEW_DIR="${PLUGIN_PREVIEW_DIR}")

# 定义后端可执行程序名称
set(DAEMON_BIN_NAME dde-grand-search-daemon)

# 定义后端应用库目录
set(DAEMON_LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${DAEMON_BIN_NAME}")

# 定义后端插件目录
set(DAEMON_PLUGIN_DIR "${DAEMON_LIB_BASE_DIR}/plugins")

# 定义后端扩展搜索插件目录
set(PLUGIN_SEARCHER_DIR "${DAEMON_PLUGIN_DIR}/searcher")
add_definitions(-DPLUGIN_SEARCHER_DIR="${PLUGIN_SEARCHER_DIR}")

add_subdirectory(src/grand-search)
add_subdirectory(src/grand-search-daemon)
add_subdirectory(src/grand-search-dock-plugin)
add_subdirectory(src/preview-plugin)

=== tests/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置工程名字
project(test-dde-grand-search)

set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_DEBUG")

set(PROJECT_SOURCE_PATH "${CMAKE_SOURCE_DIR}/../src")
set(PROJECT_3RDPARTY_PATH "${CMAKE_SOURCE_DIR}/3rdparty")

# 内存泄漏
if (NOT ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "mips"))
    ADD_DEFINITIONS(-DENABLE_SANITIZER)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-inline -fno-access-control -O0 -fprofile-arcs -ftest-coverage -lgcov")

# UT依赖
find_package(GTest REQUIRED)
find_package(Qt5 COMPONENTS Test REQUIRED)

# 全局文件
FILE(GLOB GLOBAL_SRC "${PROJECT_SOURCE_PATH}/global/*.h" "${PROJECT_SOURCE_PATH}/global/*.cpp")

# 打桩工具
FILE(GLOB CPP_STUB_SRC "${PROJECT_3RDPARTY_PATH}/cpp-stub/*.h"
    "${PROJECT_3RDPARTY_PATH}/cpp-stub/*.hpp"
    "${PROJECT_3RDPARTY_PATH}/stub-ext/*.h"
    "${PROJECT_3RDPARTY_PATH}/stub-ext/*.cpp")

include_directories("${PROJECT_3RDPARTY_PATH}/cpp-stub" "${PROJECT_3RDPARTY_PATH}/stub-ext")
include_directories(${PROJECT_SOURCE_PATH})

add_subdirectory(grand-search)
add_subdirectory(grand-search-daemon)
add_subdirectory(preview-plugin)
add_subdirectory(grand-search-dock-plugin)

=== src/grand-search-daemon/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -pie")

# 定义可执行程序名称
set(BIN_NAME ${DAEMON_BIN_NAME})

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(DtkCore REQUIRED)
#find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Concurrent
    DBus
REQUIRED)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::DBus
    Qt5::Concurrent
)

# 依赖库
set(LINK_LIBS
    ${Qt_LIBS}
    ${DtkCore_LIBRARIES}
)

# 源文件
set(DBUS
    dbusservice/grandsearchinterface_p.h
    dbusservice/grandsearchinterface.h
    dbusservice/grandsearchinterface.cpp
)

set(MAINCTRL
    maincontroller/maincontroller.h
    maincontroller/maincontroller_p.h
    maincontroller/maincontroller.cpp
    maincontroller/task/taskcommander.h
    maincontroller/task/taskcommander.cpp
    maincontroller/task/taskcommander_p.h
)

set(SEARCHER
    searcher/searchergroup.h
    searcher/searchergroup_p.h
    searcher/searchergroup.cpp
    searcher/searcher.h
    searcher/searcher.cpp
    searcher/proxyworker.h
    searcher/proxyworker.cpp
    searcher/app/desktopappsearcher.h
    searcher/app/desktopappsearcher_p.h
    searcher/app/desktopappsearcher.cpp
    searcher/app/desktopappworker.h
    searcher/app/desktopappworker.cpp
    searcher/web/statictextechoer.h
    searcher/web/statictextechoer.cpp
    searcher/web/statictextworker.h
    searcher/web/statictextworker.cpp
    searcher/extend/extendsearcher.h
    searcher/extend/extendsearcher_p.h
    searcher/extend/extendsearcher.cpp
    searcher/extend/extendworker.h
    searcher/extend/extendworker.cpp
)

#文件搜索
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips"
        OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64"
        OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw"
        OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64"
        )
    message(${CMAKE_SYSTEM_PROCESSOR} ": using fsearch")
    ADD_DEFINITIONS(-DENABLE_FSEARCH)
    FILE(GLOB 3RD_FSEARCH_SRC ${CMAKE_SOURCE_DIR}/3rdparty/fsearch/*)
    pkg_check_modules(GLIB REQUIRED glib-2.0)
    pkg_check_modules(PCRE REQUIRED libpcre)
    set(SEARCHER
        ${SEARCHER}
        ${3RD_FSEARCH_SRC}
        searcher/file/fssearcher.h
        searcher/file/fssearcher.cpp
        searcher/file/fsworker.h
        searcher/file/fsworker.cpp
        searcher/file/filesearchutils.h
        searcher/file/filesearchutils.cpp
    )
    set(LINK_LIBS
        ${LINK_LIBS}
        ${GLIB_LIBRARIES}
        ${PCRE_LIBRARIES}
    )
else ()
    message(${CMAKE_SYSTEM_PROCESSOR} ": using deepin-anything.")
    ADD_DEFINITIONS(-DENABLE_DEEPINANYTHING)
    set(SEARCHER
        ${SEARCHER}
        searcher/file/filenamesearcher.h
        searcher/file/filenamesearcher.cpp
        searcher/file/filenameworker.h
        searcher/file/filenameworker.cpp
        searcher/file/filenameworker_p.h
        searcher/file/filesearchutils.h
        searcher/file/filesearchutils.cpp
        searcher/file/anything_interface.h
        searcher/file/anything_interface.cpp
    )
endif()

# 手动生成xml描述文件
# qdbuscpp2xml -A grandsearchplugininterfacev1.h -o com.deepin.dde.grandsearch.searchplugin.xml
set(PLUGIN_ABSTRACT_IFS
    searchplugin/interface/abstract/grandsearchplugininterfacev1.h
)

# 插件通信接口
set(SEARCHPLUGIN_IFS
    searchplugin/interface/searchplugininterfacev1.h
    searchplugin/interface/searchplugininterfacev1.cpp
)

# 插件通信协议
set(SEARCHPLUGIN_PROT
    searchplugin/convertors/abstractconvertor.h
    searchplugin/convertors/abstractconvertor.cpp
    searchplugin/convertors/convertorv1_0.h
    searchplugin/convertors/convertorv1_0.cpp
)

set(SEARCHPLUGIN
    searchplugin/pluginmanager.h
    searchplugin/pluginmanager_p.h
    searchplugin/pluginmanager.cpp
    searchplugin/loader/pluginloader.h
    searchplugin/loader/pluginloader.cpp
    searchplugin/process/pluginprocess.h
    searchplugin/process/pluginprocess.cpp
    searchplugin/convertors/dataconvertor.h
    searchplugin/convertors/dataconvertor.cpp
    searchplugin/pluginliaison.h
    searchplugin/pluginliaison_p.h
    searchplugin/pluginliaison.cpp
    ${SEARCHPLUGIN_IFS}
    ${SEARCHPLUGIN_PROT}
)

set(GDCONFIGURATION
    configuration/configer.h
    configuration/configer_p.h
    configuration/configer.cpp
    configuration/preferenceitem.h
    configuration/userpreference.h
    configuration/userpreference.cpp
)

set(UTILS
    utils/searchpluginconf.h
    utils/searchplugininfo.h
    utils/searchpluginprotocol.h
    utils/specialtools.h
    utils/specialtools.cpp
    utils/chineseletterhelper.h
    utils/chineseletterhelper.cpp
    utils/searchhelper.h
    utils/searchhelper.cpp
)

set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${UTILS}
    ${DBUS}
    ${MAINCTRL}
    ${SEARCHER}
    ${SEARCHPLUGIN}
    ${GDCONFIGURATION}
)

# 资源文件
qt5_add_resources(QRC_FILES utils/dict.qrc)

# 可执行程序
add_executable(${BIN_NAME} ${SRCS} ${QRC_FILES})

target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/3rdparty/fsearch
    ${GLIB_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${LINK_LIBS}
)

# bin
install(TARGETS ${BIN_NAME} DESTINATION bin)

# dbus
install(FILES data/com.deepin.dde.daemon.GrandSearch.service DESTINATION share/dbus-1/services)

# autostart
install(FILES data/dde-grand-search-daemon.desktop DESTINATION /etc/xdg/autostart)

# 扩展搜索插件目录
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/.readme DESTINATION ${PLUGIN_SEARCHER_DIR})

=== src/grand-search-dock-plugin/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

# 定义插件名称
set(PLUGIN_NAME ddegrandsearch_dockplugin)

# 设置项目名称
project(${PLUGIN_NAME})

# 指定源码文件
set(SRCS
    ddegrandsearchdockplugin.h
    ddegrandsearchdockplugin.cpp
    gui/grandsearchwidget.h
    gui/grandsearchwidget.cpp
    gui/tipswidget.h
    gui/tipswidget.cpp
    contacts/interface/grandsearchinterface.h
    contacts/interface/grandsearchinterface.cpp
    )

# 指定资源文件
set(QRCS
    gui/resource.qrc
    )

# 指定要用到的库
find_package(Qt5Widgets REQUIRED)
find_package(DtkWidget REQUIRED)


# 加载 FindPkgConfig 模块
find_package(PkgConfig REQUIRED)

# 加载需要的库
pkg_check_modules(DdeDockInterface REQUIRED dde-dock)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

# 编译目标
add_library(${PLUGIN_NAME} SHARED ${SRCS} ${QRCS})


# 目标位置
set_target_properties(${PLUGIN_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ./)

# 设置目标要使用的 include 目录，即头文件目录
# 变量 ${DtkWidget_INCLUDE_DIRS} 是在前面执行 find_package 命令时引入的
# 当出现编译失败提示找不到某些库的头文件时应该检查此处是否将所有需要的头文件都包含了
target_include_directories(${PLUGIN_NAME} PUBLIC
    ${Qt5Widgets_INCLUDE_DIRS}
    ${DtkWidget_INCLUDE_DIRS}
    ${DdeDockInterface_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
)

# 设置目标要使用的链接库
# 变量 ${DtkWidget_LIBRARIES} 和 ${Qt5Widgets_LIBRARIES} 是在前面执行 find_package 命令时引入的
# 当出现运行时错误提示某些符号没有定义时应该检查此处是否将所有用的库都写在了这里
target_link_libraries(${PLUGIN_NAME} PRIVATE
    ${Qt5Widgets_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${DdeDockInterface_LIBRARIES}
    ${QGSettings_LIBRARIES}
)

# 设置安装路径的前缀(默认为"/usr/local")
set(CMAKE_INSTALL_PREFIX "/usr")

# 设置执行 make install 时哪个目标应该被 install 到哪个位置
# 插件.so在/usr/lib/dde-dock/plugins/下则显示在插件区域,在/usr/lib/dde-dock/plugins/system-tray/目录则显示在托盘区域
install(TARGETS ${PLUGIN_NAME} LIBRARY DESTINATION lib/dde-dock/plugins/)

# gsettings
install(FILES gschema/com.deepin.dde.dock.module.grand-search.gschema.xml DESTINATION share/glib-2.0/schemas)

=== src/grand-search/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -pie")

# 定义可执行程序名称
set(BIN_NAME ${SEARCH_BIN_NAME})

# 集成测试标签
ADD_DEFINITIONS(-DENABLE_ACCESSIBILITY)

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
    DBus
REQUIRED)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
)

# gio 打开功能需要依赖的库
pkg_check_modules(GIO_LIB REQUIRED
        gio-unix-2.0
        glib-2.0
)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

# gui
set(GUISRC
    gui/mainwindow_p.h
    gui/mainwindow.h
    gui/mainwindow.cpp
    # 可见性/退出处理
    gui/handlevisibility/handlevisibility.h
    gui/handlevisibility/handlevisibility.cpp
    # 界面相关数据定义
    gui/datadefine.h
    # 入口界面
    gui/entrance/entrancewidget_p.h
    gui/entrance/entrancewidget.h
    gui/entrance/entrancewidget.cpp
    # 展示界面
    gui/exhibition/exhibitionwidget_p.h
    gui/exhibition/exhibitionwidget.h
    gui/exhibition/exhibitionwidget.cpp
    gui/exhibition/matchresult/matchwidget_p.h
    gui/exhibition/matchresult/matchwidget.h
    gui/exhibition/matchresult/matchwidget.cpp
    gui/exhibition/matchresult/groupwidget_p.h
    gui/exhibition/matchresult/groupwidget.h
    gui/exhibition/matchresult/groupwidget.cpp
    gui/exhibition/matchresult/levelitemgroupwidget.h
    gui/exhibition/matchresult/levelitemgroupwidget.cpp
    # listView
    gui/exhibition/matchresult/listview/grandsearchlistdelegate.h
    gui/exhibition/matchresult/listview/grandsearchlistdelegate.cpp
    gui/exhibition/matchresult/listview/grandsearchlistmodel.h
    gui/exhibition/matchresult/listview/grandsearchlistmodel.cpp
    gui/exhibition/matchresult/listview/grandsearchlistview.h
    gui/exhibition/matchresult/listview/grandsearchlistview.cpp
    # preview
    gui/exhibition/preview/previewwidget.h
    gui/exhibition/preview/previewwidget.cpp
    gui/exhibition/preview/previewplugin.h
    gui/exhibition/preview/previewplugininterface.h
    gui/exhibition/preview/previewpluginmanager.h
    gui/exhibition/preview/previewpluginmanager.cpp
    gui/exhibition/preview/generalpreviewplugin_p.h
    gui/exhibition/preview/generalpreviewplugin.h
    gui/exhibition/preview/generalpreviewplugin.cpp
    gui/exhibition/preview/generalwidget/generaltoolbar.h
    gui/exhibition/preview/generalwidget/generaltoolbar.cpp
    gui/exhibition/preview/generalwidget/replicablelabel.h
    gui/exhibition/preview/generalwidget/replicablelabel.cpp
    gui/exhibition/preview/generalwidget/detailitem.h
    gui/exhibition/preview/generalwidget/detailitem.cpp
    gui/exhibition/preview/generalwidget/detailwidget.h
    gui/exhibition/preview/generalwidget/detailwidget.cpp
    gui/exhibition/preview/pluginproxy.h
    gui/exhibition/preview/pluginproxy.cpp
    gui/exhibition/preview/previewproxyinterface.h
    # setting
    gui/searchconfig/configwidget.cpp
    gui/searchconfig/configwidget.h
    gui/searchconfig/scopewidget.cpp
    gui/searchconfig/scopewidget.h
    gui/searchconfig/planwidget.cpp
    gui/searchconfig/planwidget.h
    gui/searchconfig/switchwidget/switchwidget.cpp
    gui/searchconfig/switchwidget/switchwidget.h
    gui/searchconfig/hyperlinklabel/hyperlinklabel.cpp
    gui/searchconfig/hyperlinklabel/hyperlinklabel.h
    )

# business
set(BUSINESSSRC
    # 查询控制
    business/query/querycontroller_p.h
    business/query/querycontroller.h
    business/query/querycontroller.cpp
    # 匹配结果控制
    business/matchresult/matchcontroller_p.h
    business/matchresult/matchcontroller.h
    business/matchresult/matchcontroller.cpp
    # 配置读写
    business/config/searchconfig.cpp
    business/config/searchconfig.h
    )

# contacts
set(CONTACTSSRC
    # dbus服务
    contacts/services/grandsearchservice_p.h
    contacts/services/grandsearchservice.h
    contacts/services/grandsearchservice.cpp
    contacts/services/grandsearchserviceadaptor.h
    contacts/services/grandsearchserviceadaptor.cpp
    # dbus接口
    contacts/interface/daemongrandsearchinterface.h
    contacts/interface/daemongrandsearchinterface.cpp
    )

# utils
set(UTILSSRC
    utils/utils.h
    utils/utils.cpp
    utils/previewpluginconf.h
    utils/filestatisticsthread.h
    utils/filestatisticsthread.cpp
    )

# 源文件
set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${GUISRC}
    ${BUSINESSSRC}
    ${CONTACTSSRC}
    ${UTILSSRC}
)

# 指定资源文件
set(QRCS
    gui/searchconfig/resource.qrc
    gui/exhibition/preview/resource.qrc
    )

add_executable(${BIN_NAME} ${SRCS} ${QRCS})

target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${GIO_LIB_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${GIO_LIB_LIBRARIES}
)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# bin
install(TARGETS ${BIN_NAME} DESTINATION bin)

# ts
install(DIRECTORY ${PROJECT_SOURCE_DIR}/translations
    DESTINATION share/${BIN_NAME}
    FILES_MATCHING PATTERN "*.qm")

# dbus
install(FILES contacts/services/com.deepin.dde.GrandSearch.service DESTINATION share/dbus-1/services)
install(FILES contacts/services/com.deepin.dde.GrandSearch.xml DESTINATION share/dbus-1/interfaces)

=== tests/grand-search-daemon/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need -fPIE")

# 应用库目录
set(LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${BIN_NAME}")

# 插件目录
set(PLUGIN_DIR "${LIB_BASE_DIR}/plugins")

# 扩展搜索插件目录
set(PLUGIN_SEARCHER_DIR "${PLUGIN_DIR}/searcher")
add_definitions(-DPLUGIN_SEARCHER_DIR="${PLUGIN_SEARCHER_DIR}")

# 定义可执行程序名称
set(BIN_NAME test-dde-grand-search-daemon)

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(DtkCore REQUIRED)
#find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Concurrent
    DBus
REQUIRED)

set(PROJECT_DAEMONSRC_PATH "${PROJECT_SOURCE_PATH}/grand-search-daemon")
include_directories(${PROJECT_DAEMONSRC_PATH})

ADD_DEFINITIONS(-DENABLE_FSEARCH)
FILE(GLOB 3RD_FSEARCH_SRC ${CMAKE_SOURCE_DIR}/../3rdparty/fsearch/*)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(PCRE REQUIRED libpcre)

if (NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw"))
    ADD_DEFINITIONS(-DENABLE_DEEPINANYTHING)
else()
    # 移除不支持的文件
    FILE(GLOB_RECURSE RM_DASRC
        "${PROJECT_DAEMONSRC_PATH}/searcher/file/filename*"
        "${PROJECT_DAEMONSRC_PATH}/searcher/file/anything*"
        )
endif()

# 项目工程文件
FILE(GLOB_RECURSE PRO_SRC "${PROJECT_DAEMONSRC_PATH}/*/*.h" "${PROJECT_DAEMONSRC_PATH}/*/*.cpp")

# 移除未编写的文件
FILE(GLOB_RECURSE RM_SRC
    "${PROJECT_DAEMONSRC_PATH}/searchplugin/interface/abstract/*"
    )
list(REMOVE_ITEM PRO_SRC ${RM_SRC} ${RM_DASRC})

#单元测试文件
FILE(GLOB_RECURSE UT_SRC "./*/*.cpp")

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::DBus
    Qt5::Concurrent
)

set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${PRO_SRC}
    ${UT_SRC}
    ${CPP_STUB_SRC}
    ${3RD_FSEARCH_SRC}
)

# 可执行程序
add_executable(${BIN_NAME} ${SRCS})

target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/../3rdparty/fsearch
    ${GLIB_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkCore_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${PCRE_LIBRARIES}
    -lpthread
)

=== tests/grand-search/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need -fPIE")

# 定义可执行程序名称
set(BIN_NAME test-dde-grand-search)

# 应用库目录
set(LIB_BASE_DIR "${LIB_PLATFORM_DIR}/${BIN_NAME}")

# 插件目录
set(PLUGIN_BASE_DIR "${LIB_BASE_DIR}/plugins")

# 预览插件目录
set(PLUGIN_PREVIEW_DIR "${PLUGIN_BASE_DIR}/preview")
add_definitions(-DPLUGIN_PREVIEW_DIR="${PLUGIN_PREVIEW_DIR}")

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Widgets
    Concurrent
    DBus
REQUIRED)

pkg_check_modules(GIO_LIB REQUIRED
        gio-unix-2.0
        glib-2.0
)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
)

set(PROJECT_SRC_PATH "${PROJECT_SOURCE_PATH}/grand-search")
include_directories(${PROJECT_SRC_PATH})

#项目工程文件
FILE(GLOB_RECURSE PRO_SRC "${PROJECT_SRC_PATH}/*/*.h" "${PROJECT_SRC_PATH}/*/*.cpp")

#单元测试文件
FILE(GLOB_RECURSE UT_SRC "./*/*.cpp")

# 源文件
set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${PRO_SRC}
    ${UT_SRC}
    ${CPP_STUB_SRC}
)

add_executable(${BIN_NAME} ${SRCS})
target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
    ${GIO_LIB_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    ${GIO_LIB_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    -lpthread
)

=== src/preview-plugin/image-preview/CMakeLists.txt ===
project(image-preview)

# 定义插件名称
set(LIB_NAME image-preview-plugin)

set(SRCS
    imagepreviewinterface.h
    imagepreviewinterface.cpp
    imagepreviewplugin.h
    imagepreviewplugin.cpp
    imageview.h
    imageview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS} ${QRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})

# conf
install(FILES image-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== src/preview-plugin/pdf-preview/CMakeLists.txt ===
project(pdf-preview)

# 定义插件名称
set(LIB_NAME pdf-preview-plugin)

find_package(PkgConfig REQUIRED)
pkg_check_modules(PDF REQUIRED poppler-qt5)

set(SRCS
    pdfpreviewinterface.h
    pdfpreviewinterface.cpp
    pdfpreviewplugin.h
    pdfpreviewplugin.cpp
    pdfview.h
    pdfview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS} ${QRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${PDF_INCLUDE_DIRS}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${PDF_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/pdf-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== debian/changelog ===
dde-grand-search (5.2.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 17 Mar 2022 14:17:19 +0800

dde-grand-search (1.0) unstable; urgency=medium

  * Pre-release for dde-grand-search 1.0

 -- Zhang Yu <zhangyub@uniontech.com>  Mon, 5 Jul 2021 16:40:00 +0800

=== debian/control ===
Source: dde-grand-search
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9),
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 libdtkwidget-dev,
 libdtkcore-dev,
 libdtkgui-dev,
 libdtkcore5-bin,
 libdframeworkdbus-dev (>=5.4.6),
 qttools5-dev-tools,
 cmake,
 dde-dock-dev,
 libglib2.0-dev,
 libpoppler-qt5-dev,
 libffmpegthumbnailer-dev,
 libavformat-dev,
 libavcodec-dev,
 libtag1-dev,
 libicu-dev,
 libgsettings-qt-dev,
 libpcre3-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org/

Package: dde-grand-search
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 deepin-desktop-schemas (>=5.8.0.34),
 dde-daemon (>=5.12.0.31),
 libdframeworkdbus2 (>=5.4.6),
 startdde (>=5.6.0.34),
 libpoppler-qt5-1,
 libavformat58(>= 7:4.1),
 libavutil56(>= 7:4.0),
 libavcodec58(>= 7:4.0),
 libffmpegthumbnailer4v5,
 libtag1v5
Recommends:
 deepin-anything-server[i386 amd64]
Description: deepin desktop-environment - search module
 Search module of deepin desktop-environment

## dde-grand-search 5.3.1

=== src/grand-search-daemon/CMakeLists.txt ===
--- 
+++ 
@@ -13,10 +13,11 @@
 # 依赖包
 find_package(PkgConfig REQUIRED)
 find_package(DtkCore REQUIRED)
-#find_package(DtkCMake REQUIRED)
+find_package(DtkWidget REQUIRED)
 find_package(Qt5 COMPONENTS
     Core
     Gui
+    Widgets
     Concurrent
     DBus
 REQUIRED)
@@ -24,6 +25,7 @@
 set(Qt_LIBS
     Qt5::Core
     Qt5::Gui
+    Qt5::Widgets
     Qt5::DBus
     Qt5::Concurrent
 )
@@ -32,6 +34,7 @@
 set(LINK_LIBS
     ${Qt_LIBS}
     ${DtkCore_LIBRARIES}
+    ${DtkWidget_LIBRARIES}
 )
 
 # 源文件
@@ -171,8 +174,6 @@
     utils/specialtools.cpp
     utils/chineseletterhelper.h
     utils/chineseletterhelper.cpp
-    utils/searchhelper.h
-    utils/searchhelper.cpp
 )
 
 set(SRCS
@@ -194,6 +195,7 @@
 
 target_include_directories(${BIN_NAME} PUBLIC
     ${CMAKE_SOURCE_DIR}/include
+    ${DtkWidget_INCLUDE_DIRS}
     ${CMAKE_SOURCE_DIR}/3rdparty/fsearch
     ${GLIB_INCLUDE_DIRS}
     ${PCRE_INCLUDE_DIRS}

=== src/grand-search/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
     Qt5::Gui
     Qt5::Widgets
     Qt5::DBus
+    Qt5::Concurrent
 )
 
 # gio 打开功能需要依赖的库
@@ -65,8 +66,6 @@
     gui/exhibition/matchresult/groupwidget_p.h
     gui/exhibition/matchresult/groupwidget.h
     gui/exhibition/matchresult/groupwidget.cpp
-    gui/exhibition/matchresult/levelitemgroupwidget.h
-    gui/exhibition/matchresult/levelitemgroupwidget.cpp
     # listView
     gui/exhibition/matchresult/listview/grandsearchlistdelegate.h
     gui/exhibition/matchresult/listview/grandsearchlistdelegate.cpp
@@ -102,6 +101,14 @@
     gui/searchconfig/scopewidget.h
     gui/searchconfig/planwidget.cpp
     gui/searchconfig/planwidget.h
+    gui/searchconfig/customwidget.cpp
+    gui/searchconfig/customwidget.h
+    gui/searchconfig/tailerwidget.cpp
+    gui/searchconfig/tailerwidget.h
+    gui/searchconfig/checkboxwidget/checkboxwidget.cpp
+    gui/searchconfig/checkboxwidget/checkboxwidget.h
+    gui/searchconfig/checkboxwidget/checkboxitem.cpp
+    gui/searchconfig/checkboxwidget/checkboxitem.h
     gui/searchconfig/switchwidget/switchwidget.cpp
     gui/searchconfig/switchwidget/switchwidget.h
     gui/searchconfig/hyperlinklabel/hyperlinklabel.cpp
@@ -121,6 +128,9 @@
     # 配置读写
     business/config/searchconfig.cpp
     business/config/searchconfig.h
+    # 访问记录
+    business/config/accessrecord/accessrecord.h
+    business/config/accessrecord/accessrecord.cpp
     )
 
 # contacts

=== tests/grand-search-dock-plugin/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need -fPIE")

# 定义可执行程序名称
set(BIN_NAME test-dde-grand-search-dock-plugin)

# 查找gmock的cmake文件
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/../tests/cmake/modules)

# 依赖包
find_package(PkgConfig REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(GMock REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Widgets
    DBus
    Concurrent
REQUIRED)

set(Qt_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Concurrent
)

pkg_check_modules(DdeDockInterface REQUIRED dde-dock)
pkg_check_modules(QGSettings REQUIRED gsettings-qt)

set(PROJECT_SRC_PATH "${PROJECT_SOURCE_PATH}/grand-search-dock-plugin")
include_directories(${PROJECT_SRC_PATH}
    ${PROJECT_SOURCE_PATH}/grand-search-dock-plugin/gui)

#项目工程文件
FILE(GLOB_RECURSE PRO_SRC "${PROJECT_SRC_PATH}/*.h" "${PROJECT_SRC_PATH}/*.cpp")

#单元测试文件
FILE(GLOB_RECURSE UT_SRC "./*.cpp" )

# 源文件
set(SRCS
    main.cpp
    ${GLOBAL_SRC}
    ${PRO_SRC}
    ${UT_SRC}
    ${CPP_STUB_SRC}
)

add_executable(${BIN_NAME} ${SRCS} ${QRCS})

target_include_directories(${BIN_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${DdeDockInterface_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGui_LIBRARIES}
    ${DdeDockInterface_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
    ${GMOCK_LIBRARIES}
    ${Qt5Test_LIBRARIES}
    -lpthread
)

=== tests/grand-search/CMakeLists.txt ===
--- 
+++ 
@@ -44,6 +44,7 @@
     Qt5::Gui
     Qt5::Widgets
     Qt5::DBus
+    Qt5::Concurrent
 )
 
 set(PROJECT_SRC_PATH "${PROJECT_SOURCE_PATH}/grand-search")

=== src/preview-plugin/audio-preview/CMakeLists.txt ===
project(audio-preview)

# 定义插件名称
set(LIB_NAME audio-preview-plugin)
find_package(PkgConfig REQUIRED)
pkg_check_modules(TAGLIB REQUIRED taglib)
pkg_check_modules(AVFORMAT REQUIRED libavformat)
pkg_check_modules(ICU REQUIRED icu-i18n)

set(SRCS
    audiopreviewinterface.h
    audiopreviewinterface.cpp
    audiopreviewplugin.h
    audiopreviewplugin.cpp
    audiofileinfo.h
    audiofileinfo.cpp
    audioview.h
    audioview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${TAGLIB_INCLUDE_DIRS}
    ${AVFORMAT_INCLUDE_DIRS}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${TAGLIB_LIBRARIES}
    ${AVFORMAT_LIBRARIES}
    ${ICU_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/audio-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== src/preview-plugin/text-preview/CMakeLists.txt ===
project(text-preview)

# 定义插件名称
set(LIB_NAME text-preview-plugin)

set(SRCS
    textpreviewinterface.h
    textpreviewinterface.cpp
    textpreviewplugin.h
    textpreviewplugin.cpp
    textview.h
    textview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS} ${QRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})

# conf
install(FILES text-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== src/preview-plugin/video-preview/CMakeLists.txt ===
project(video-preview)

# 定义插件名称
set(LIB_NAME video-preview-plugin)

pkg_check_modules(Avformat REQUIRED libavformat)
pkg_check_modules(Ffm REQUIRED libffmpegthumbnailer)

set(SRCS
    videopreviewinterface.h
    videopreviewinterface.cpp
    videopreviewplugin.h
    videopreviewplugin.cpp
    videoview.h
    videoview.cpp
)

add_library(${LIB_NAME} SHARED ${SRCS} ${QRCS})

target_include_directories(${LIB_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${DtkGUI_INCLUDE_DIRS}
    ${Avformat_INCLUDE_DIRS}
    ${Ffm_INCLUDE_DIRS}
)

target_link_libraries(${LIB_NAME} PRIVATE
    ${Qt_LIBS}
    ${DtkWidget_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${Avformat_LIBRARIES}
    ${Ffm_LIBRARIES}
)

# bin
install(TARGETS ${LIB_NAME} DESTINATION ${PLUGIN_PREVIEW_DIR})

# conf
install(FILES video-preview-plugin.conf DESTINATION ${PLUGIN_PREVIEW_DIR})

=== debian/changelog ===
dde-grand-search (5.3.1-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 29 Apr 2022 09:16:11 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export QT_SELECT = 5

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

## dde-grand-search 5.3.2

=== src/grand-search/CMakeLists.txt ===
--- 
+++ 
@@ -73,6 +73,9 @@
     gui/exhibition/matchresult/listview/grandsearchlistmodel.cpp
     gui/exhibition/matchresult/listview/grandsearchlistview.h
     gui/exhibition/matchresult/listview/grandsearchlistview.cpp
+    # viewMore
+    gui/exhibition/matchresult/viewmore/viewmorebutton.cpp
+    gui/exhibition/matchresult/viewmore/viewmorebutton.h
     # preview
     gui/exhibition/preview/previewwidget.h
     gui/exhibition/preview/previewwidget.cpp
@@ -105,6 +108,8 @@
     gui/searchconfig/customwidget.h
     gui/searchconfig/tailerwidget.cpp
     gui/searchconfig/tailerwidget.h
+    gui/searchconfig/searchenginewidget.cpp
+    gui/searchconfig/searchenginewidget.h
     gui/searchconfig/checkboxwidget/checkboxwidget.cpp
     gui/searchconfig/checkboxwidget/checkboxwidget.h
     gui/searchconfig/checkboxwidget/checkboxitem.cpp
@@ -113,6 +118,10 @@
     gui/searchconfig/switchwidget/switchwidget.h
     gui/searchconfig/hyperlinklabel/hyperlinklabel.cpp
     gui/searchconfig/hyperlinklabel/hyperlinklabel.h
+    gui/searchconfig/comboboxwidget/comboboxwidget.h
+    gui/searchconfig/comboboxwidget/comboboxwidget.cpp
+    gui/searchconfig/bestmatchwidget.cpp
+    gui/searchconfig/bestmatchwidget.h
     )
 
 # business

=== debian/changelog ===
dde-grand-search (5.3.2-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 06 Jun 2022 15:26:40 +0800
